// ==========================================
//           Draggable Posts order
// ==========================================

function launchDraggableOrder() {
    $("form .article_group").sortable({
        handle: "h3 span.sortable-handle",
        axis: "y",
        scroll: false,
        start: function(event, ui) {
            $("form article .buttons").fadeOut(ANIMATION_TIME / 2);
        },
        stop: function(event, ui) {
            $("form article .buttons").fadeIn(ANIMATION_TIME);
        },
        update: function(event, ui) {
            setPostButtons();
        }
    });
    
    setTimeout(function() {
        $("form .disable-sortable").each(function() {
            $(this).sortable("disable");
            $(this).find("h3 span.sortable-handle").removeClass("sortable-handle");
        })
    }, ANIMATION_TIME * 2);
};

// ==========================================
//           Section fold & expand
// ==========================================

function sectionsFold($button) {
    var $article = $button.closest("article");
    $("article .fold_expand span.fold").hide();
    $("article .fold_expand span.expand").show();
    var keep_visible = [ "title", "name" ];
    $("article section").each(function() {
        if(keep_visible.indexOf($(this).attr("class")) < 0) { $(this).hide(ANIMATION_TIME); };
    })
    setTimeout(function() { scrollTo($article); }, ANIMATION_TIME * 2);
    formResize(ANIMATION_TIME + 100);
}

function sectionsExpand($button) {
    var $article = $button.closest("article");
    $("article .fold_expand span.expand").hide();
    $("article .fold_expand span.fold").show();
    $("article section").show(ANIMATION_TIME);
    formResize(ANIMATION_TIME + 100);
    setTimeout(function() { scrollTo($article); }, ANIMATION_TIME * 2)
}

function initializeSectionFold() {
    // Buttons
    $(".fold_expand span.fold").unbind("click").click(function() {
        $(this).blur();
        sectionsFold($(this));
    });
    $(".fold_expand span.expand").unbind("click").click(function() {
        $(this).blur();
        sectionsExpand($(this));
    });        
};

function autoSectionFold() {
    $(".fold_expand span.expand").hide();
    // Fold long content
    n = 1;
    fold_big_from = 9;
    fold_all_from = 9;
    big_size = $(window).height() * 0.5;
    $("form article").each(function() {
        n++;
        $article = $(this);
        if((n > fold_big_from && $article.height() > big_size) || (n > fold_all_from)) {
            $article.find(".fold_expand span.expand").show();
            $article.find(".fold_expand span.fold").hide();
            $article.find("section").hide();
        }
    });
};

function launchSectionFold() {
    if(!$("#site_auto_section_fold").length || $("#site_auto_section_fold").val() != "false") {
        autoSectionFold();
    }
    else {
        $("form article .fold_expand span.expand").hide();
    };
    formResize(750);
};

// ==========================================
//               Action Button
// ==========================================

function actionButton($button) {
    var href = $button.attr("href");
    href = href.replace("@root", $("input#root").val(), href);
    href = href.replace("@edit_path", $("input#edit_path").val(), href);
    href = href.replace("@filename", $("input#edit_path").val().path("filename"), href);
    if(href.substr(0, 5) == "form:") {
        href = href.substr(5);
        // Copy input values to new form (text, textarea, string, code)
        $("body").append("<form id='active_form' method='post' action='" + href + "'>\n</form>");
        $button.closest("article").find("section").each(function() {
            name = $(this).attr("class");
            $(this).find("input, textarea").each(function() {
                if($(this).css("display") != "none" && $(this).attr("class") != "type") {
                    input = "\t<input type='hidden' name='" + name + "' value='" + $(this).val() + "'>\n";
                    $("#active_form").append(input);
                }
            })
        })
        //alert("FORM:\n" + $("#active_form").html() );
        $("#active_form").submit();
        // Please wait info
        $("#upload_info p").text(LOCALIZE["please-wait"]);
        $("#upload_info").fadeIn(500);
    }
    else if(href.indexOf("link:") == 0) {
        window.open(href.substr(5));
        $button.blur();
    }
    else if(href.indexOf("action:") == 0) {
        $button.blur();
    }
    else if(href.indexOf("href:") == 0) {
        $("#loader").fadeIn(500);
        location.href = href.substr(5);
    }
    else {
        $("#loader").fadeIn(500);
        location.href = href;
    }
};

function initializeActionButtons() {
    $("a.active_link, button.action_button, footer .unsaved").unbind("click").click(function() {
        var $button = $(this);
        if(detectChanges()) {
            showPopup("fi-alert", LOCALIZE["unsaved-changes-alert"], LOCALIZE["yes-no-buttons"]);
            $("#popup_box .confirm").click(function() { hidePopup(); actionButton($button); });
            $("#popup_box .cancel").click(function() { hidePopup(); return false; });
        }
        else {
            actionButton($button);
        }
        return false;
    })
};

// ==========================================
//        Set Buttons & Article headers
// ==========================================

function headerTag(tag) {
    if(tag.substr(0, 6) == "multi_") { tag = tag.substr(6); };
    //return translate( tag.replace(/_/g, " ").toUpperCase() );
    return translate(tag).replace(/_/g, " ").toUpperCase();
};

function setPostButtons() {
    // (re)Enable all buttons
    $("form article > .buttons").find("button").prop("disabled", false).removeClass("disabled");
    // Hide buttons & add titles
    var num = 0;
    $("form article").each(function() {
        var tag = getItemTag($(this));
        if($(this).find("h3").length) { // skip options article
            if(tag.substr(0, 6) == "multi_" || tag.substr(0, 1) == "_") {
                if(!getNextItem($(this), -1)) {
                    num = 1;
                    $(this).children(".buttons").find(".up, .up_top").prop("disabled", true).addClass("disabled");
                };
                if(!getNextItem($(this), 1)) {
                    if(num < 3) {
                        $("form article." + tag).children(".buttons").find(".jump").prop("disabled", true).addClass("disabled");
                    };
                    if(num == 1) {
                        $("form article." + tag).children(".buttons").find(".delete").prop("disabled", true).addClass("disabled");
                    };
                    $(this).children(".buttons").find(".down, .down_bottom").prop("disabled", true).addClass("disabled");
                };
                if(tag.substr(0, 1) != "_") {
                    $(this).find("h3").html("<span class='fi-comments sortable-handle'></span>" + headerTag(tag) + " " + num);
                };
                num++;
            }
            else {
                num = 0;
                $(this).find("h3").html("<span class='fi-comment'></span>" + headerTag(tag));
            }
        }
    })
};

// ==========================================
//            Move or delete post
// ==========================================

function getTagClassKey($item) {
    var item_tag = $item.prop("tagName").toLowerCase();
    var item_class = $item.attr("class");
    if(typeof(item_class) == "string" && item_class != "") {
        return item_tag + "." + item_class.split(" ").shift();
    }
    else {
        return item_tag;
    }
};

function getNextItem($item, dir) {
    var item_tag = $item.prop("tagName");
    var item_class =  $item.attr("class").split(" ").shift();
    var $next = false;
    while($item.length && (!$next || dir > 1 || dir < -1)) {
        if(dir > 0) { $item = $item.next(); }
        else { $item = $item.prev(); };
        if($item.length && $item.prop("tagName") == item_tag && $item.attr("class").split(" ").indexOf(item_class) > -1) { 
            $next = $item;
        }
    }
    return $next;
};

function initializePostButtons() {
// --------------------------------
// Initiate post buttons actions
// --------------------------------
    $("article .buttons").find(".delete, .disabled, .down, .up").unbind("click");

    // ====== Delete ======
    $("article .buttons button.delete").click(function() {
        $item = $(this).closest("article");
        $item.find("section > div.media").children("div").each(function() {
            attachments = [ "image", "gallery", "file", "files"];
            if(attachments.indexOf($(this).attr("class")) > -1) {
                path = $(this).attr("value");
                if(jQuery.type(path) == "string" && path != "") {
                    ext = path.path("extension");
                    if(jQuery.type(ext) == "string" && ext != "") {
                        addToDeleteFiles(path);
                    };
                };
            };
        });

        // Navigation item remove info
        if(SAVE_PATH.path("basename") == "navigation.json") {
            infoPopup(LOCALIZE["nav-item-remove-info"]);
        };

        $item.hide(500, function() {
            $(this).remove();
            setPostButtons();
        });

        formResize(550);
        return false; 
    });

    // ====== Move up ======
    $("article .buttons button.up").click(function() {
        $item = $(this).closest("article");
        $swapWith = getNextItem($item, -1);
        if($swapWith) {
            $item.hide(250, function() {
                //$swapWith = $item.prev("article");
                $item.after($swapWith.detach());
                $item.show(250, function() {
                    $(".ui-drop-box").remove();
                    setPostButtons();
                    initializePostButtons();
                    var key = getTagClassKey($item);
                    initializeDroppableOrder(key);
                    initializeToggleDraggable(key);
                    scrollTo($item);
                })
            })
        };
        $(this).blur();
        return false;
    });

    // ====== Move Down ======
    $("article .buttons button.down").click(function() {
        $item = $(this).closest("article");
        $swapWith = getNextItem($item, 1);
        if($swapWith) {
            $item.hide(250, function() {
                //$swapWith = $item.prev("article");
                $item.before($swapWith.detach());
                $item.show(250, function() {
                    $(".ui-drop-box").remove();
                    setPostButtons();
                    initializePostButtons();
                    var key = getTagClassKey($item);
                    initializeDroppableOrder(key);
                    initializeToggleDraggable(key);
                    scrollTo($item);
                })
            })
        };
        $(this).blur();
        return false;
    });

    // ====== Move to top ======
    $("article .buttons button.up_top").click(function() {
        $swapWith = $(this).closest("article");
        $swapWith.find("button").removeClass("disabled").prop("disabled", false);
        
        $item = getNextItem($swapWith, -2);
        if($item) {
            $swapWith.hide(250, function() {
                $item.before($swapWith.detach());
                $swapWith.show(250, function() {
                    $(".ui-drop-box").remove();
                    setPostButtons();
                    initializePostButtons();
                    var key = getTagClassKey($swapWith);
                    initializeDroppableOrder(key);
                    initializeToggleDraggable(key);
                    scrollTo($swapWith);
                })
            })
        };
        $(this).blur();
        return false;
    });

    // ====== Move to bottom ======
    $("article .buttons button.down_bottom").click(function() {
        $swapWith = $(this).closest("article");
        $swapWith.find("button").removeClass("disabled").prop("disabled", false);
        $item = getNextItem($swapWith, 2);
        if($item) {
            $swapWith.hide(250, function() {
                $item.after($swapWith.detach());
                $swapWith.show(250, function() {
                    $(".ui-drop-box").remove();
                    setPostButtons();
                    initializePostButtons();
                    var key = getTagClassKey($swapWith);
                    initializeDroppableOrder(key);
                    initializeToggleDraggable(key);
                    scrollTo($swapWith);
                })
            })
        };
        $(this).blur();
        return false;
    });

    // ====== Disabled ======
    $("article .buttons button.disabled").click(function() {
        $(this).blur();
        return false;
    })

};

// ==========================================
//           Add new Post (article)
// ==========================================

function initializeNewPost() {        
    $("article button.new").unbind("click").click(function() {
        $(this).unbind();
        tag = $(this).attr("class").split(" ").pop();
        $("#style_buttons").remove(); // Remove temporary elements if any
        // Add new post (not displayed)
        //alert(tag);
        html = $(this).closest("article").html();
        html = html.replace(/name=\"(.*?)\"/ig, "name=\"$1-new\""); // Change name(s) -> multiple files need fix!
        html = html.replace(/id=\"(.*?)\"/ig, "id=\"$1-new\""); // Change id(s)
        html = html.replace(/for=\"(.*?)\"/ig, "for=\"$1-new\""); // Change for

        // ====== Add new article ======
        // Below
        //if(CURRENT_PATH.path("filename") == "navigation") { // if Nav -> add new article on the end
        if(SITE_NEW_BELOW.indexOf(tag) > -1) {
            $(this).closest("article").after("<article class='" + tag + "' style='display:none'>" + html + "</article>");
            $new_post = $(this).closest("article").next();
        }
        // Above
        else {
            $(this).closest("article").before("<article class='" + tag + "' style='display:none'>" + html + "</article>");
            $new_post = $(this).closest("article").prev();
        }

        // Clear edit fields
        $new_post.children("section").each(function() {
            $(this).children("div.text").children("input, textarea").val(""); // Clear all text fields
            $(this).children("input.string, input.code, textarea.code, input.date").val(""); // Clear all string & code fields
            $(this).find("ul.checkbox li input").prop("checked", false); // Uncheck any checkbox options
            $(this).find("ul.radio").each(function() { // Select first radio option
                $(this).find("li input").prop("checked", false);
                $(this).find("li input").first().prop("checked", true);
            });
            // table
            $(this).find("table").find("td").each(function() {
                id = $(this).attr("class");
                if(id.split(" ").length == 1 && id.split("_").shift() == "num") {
                    $(this).text("");
                };
            });
            // media
            $(this).find("div.set").each(function() {
                // If "none" exists -> default
                if($(this).closest("section").find("div.media").children("div").length == 1) {} // one set type
                else if( $(this).find("[value=none]").length > 0 ) {
                    $(this).find("input").prop("checked", false);
                    $(this).find("[value=none]").prop("checked", true);

                }
                // If no "none", first -> default
                else {
                    $(this).find("input").prop("checked", false);
                    $(this).find("input:first").prop("checked", true);
                };
            });

            $(this).find(".upload label").removeClass("fi-photo").addClass("fi-upload");
            $(this).find(".upload").css({ "background-color": "transparent" });
            $(this).find("div.file label p").text(LOCALIZE["add-file"]);
            $(this).find("div.image label p").text(LOCALIZE["add-image"]);
            $(this).find("div.gallery label p").text(LOCALIZE["add-images"]);
            $(this).find("div.files label p").text(LOCALIZE["add-files"]);
            $(this).find("div.upload input.upload_file").prop("disabled", false); // Unblock label(s) disabled by cancelFix

            // File
            $(this).children("div.media").children("div.file").each(function() {
                src = $(this).attr("value");
                $(this).attr("value", src.path("dirname"));
                $(this).find(".thumb").hide().remove();
                $(this).find(".upload").show();
            });
            // Image
            $(this).children("div.media").children("div.image").each(function() {
                src = $(this).attr("value");
                $(this).attr("value", src.path("dirname"));
                $(this).find(".thumb").hide().remove();
                $(this).find(".upload").show();
            });
            // Files
            $(this).children("div.media").children("div.files").each(function() {
                $(this).find(".fake").remove();
                src = $(this).attr("value").split(";").shift();
                $(this).attr("value", src.path("dirname"));

                $(this).find(".thumb").hide().remove();
                // multiple file name fix
                name = $(this).find("input.upload_file").attr("name");
                name = name.replace("[]", "");

                $(this).find("input.upload_file").attr("name", name + "[]");
            });
            // Gallery
            $(this).children("div.media").children("div.gallery").each(function() {
                $(this).find(".fake").remove();
                src = $(this).attr("value").split(";").shift();
                $(this).attr("value", src.path("dirname"));

                $(this).find(".thumb").hide().remove();
                // multiple file name fix
                name = $(this).find("input.upload_file").attr("name");
                name = name.replace("[]", "");
                $(this).find("input.upload_file").attr("name", name + "[]");
            });
            // Video
            $(this).find("div.media div.video").attr("value", "");
            $(this).find("div.media div.video iframe").hide().attr("src", "");
            $(this).find("div.media div.video button.delete").hide();
            // File inputs
            /*
            $(this).find("input.upload_file").each(function() {
                $(this).val("");
            });
            */

        });
        // unique ID
        if($new_post.find("._id").length) {
            $id = $new_post.find("._id input.string");
            date = currentTime("yyyymmdd");
            var id_max = 0;
            $("section._id").each(function() {
                val = $(this).find("input.string").val().split("-");
                if(val.length == 2 && val[0] == date) {
                    if(val[1] > id_max) {
                        id_max = val[1];
                    };
                };
            })
            $id.val(date + "-" + ++id_max);
        };
        // auto DATE
        $new_post.find("._date input.string").val(currentTime("yyyy-mm-dd"));

        // Hide help popup
        $("#help_popup").remove();
        // Display new post
        $new_post.show(500, function() {
            $(this).blur();
            // reinitialize active elements on new DOM content
            reinitializePostActiveElements();
            // Scroll to new post
            setTimeout(function() { $('html, body').animate({ scrollTop: $new_post.offset().top }, 500); }, 250);
            //Auto focus on first input
            $new_post.find("input.string, input." + LANG + ", textarea." + LANG).first().focus();
            // Initialize draggable
            $new_post.addClass("ui-add-draggable");
            initializeDraggableOrder(".ui-add-draggable");
            $new_post.removeClass("ui-add-draggable");
        });

        if(SAVE_PATH.path("basename") == "navigation.json") {
            infoPopup(LOCALIZE["nav-item-add-info"]);
        };

        return false;
    });
};

function reinitializePostActiveElements() {
    initializeDectectChanges();
    initializeUpload();
    mediaHideShow();
    singleSetHide();
    setPostButtons();
    initializePostButtons();
    initializeShowStyle();
    initializeHelp();
    initializeNewPost();
    initializeSectionFold();
    transparentBackground();
    initializeDisabled();
    initializeTable();
    initializeActionButtons();
    initializeDateInput();
    initializeBrowseInput();
    initializeSet();
    $("form article section.string").each(function() { updateString($(this), false); });
}